Index: /trunk/SophyaPI/PIext/basexecut.cc
===================================================================
--- /trunk/SophyaPI/PIext/basexecut.cc	(revision 1568)
+++ /trunk/SophyaPI/PIext/basexecut.cc	(revision 1569)
@@ -748,7 +748,9 @@
 usage += ">> Lines:  defline normalline thinline thickline dashedline thindashedline \n";
 usage += "           thickdashedline dottedline thindottedline thickdottedline \n";
-usage += ">> Fonts:  deffont normalfont boldfont italicfont smallfont smallboldfont \n";
-usage += "           smallitalicfont bigfont bigboldfont bigitalicfont \n";
-usage += "           hugefont  hugeboldfont hugeitalicfont \n";
+usage += ">> Font Att: deffontatt normalfont boldfont italicfont bolditalicfont  \n";
+usage += "             smallfont smallboldfont smallitalicfont smallbolditalicfont \n";
+usage += "             bigfont bigboldfont bigitalicfont bigbolditalicfont \n";
+usage += "             hugefont  hugeboldfont hugeitalicfont hugebolditalicfont \n";
+usage += ">> Font Names: deffont courierfont helveticafont timesfont symbolfont  \n";
 usage += ">> Marker: dotmarker<T>  plusmarker<T>  crossmarker<T> circlemarker <T> \n";
 usage += "           fcirclemarker<T> boxmarker<T> fboxmarker<T> trianglemarker<T> \n";
Index: /trunk/SophyaPI/PIext/pistdimgapp.cc
===================================================================
--- /trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 1568)
+++ /trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 1569)
@@ -200,4 +200,5 @@
 mFCol = mBCol = PI_NotDefColor;
 mLAtt = PI_NotDefLineAtt;
+mFName = PI_DefaultFont;   
 mFSz = PI_NotDefFontSize;
 mFAtt = PI_NotDefFontAtt;
@@ -523,4 +524,5 @@
 if (mLAtt != PI_NotDefLineAtt) scd->SetLineAtt(mLAtt);
 if ( (mFSz != PI_NotDefFontSize) && (mFAtt != PI_NotDefFontAtt) ) scd->SetFontAtt(mFSz, mFAtt); 
+if ( mFName != PI_DefaultFont ) scd->SetFont(mFName, scd->GetFontSz(), scd->GetFontAtt());
 if ( (mMrk != PI_NotDefMarker) && (mMSz >= 0) ) scd->SetMarkerAtt(mMSz, mMrk);
 if ( mCmapid != CMAP_OTHER ) scd->SetColMapId(mCmapid);
@@ -569,4 +571,6 @@
   scw->SetLimits(mXmin, mXmax, mYmin, mYmax);
 scw->SetAxesFlags(mAxesFlags);
+// Fonte de trace d'axe
+scw->BaseDrawer()->SetFont(mFName, mFSz, mFAtt);
 
 if (typeid(*scd) != typeid(PIHisto2D)) scw->AddScDrawer(scd, true);
@@ -577,4 +581,5 @@
   scw->SetTitles(title, t2);    
 }
+
 // scw->Refresh();   ? Pas necessaire  Reza 19/08/98, 05/05/99 $CHECK$ 
 mCurWin = win;
@@ -599,4 +604,5 @@
 if (mLAtt != PI_NotDefLineAtt) dr3->SetLineAtt(mLAtt);
 if ( (mFSz != PI_NotDefFontSize) && (mFAtt != PI_NotDefFontAtt) ) dr3->SetFontAtt(mFSz, mFAtt); 
+if ( mFName != PI_DefaultFont ) dr3->SetFont(mFName, dr3->GetFontSz(), dr3->GetFontAtt());
 if ( (mMrk != PI_NotDefMarker) && (mMSz >= 0) ) dr3->SetMarkerAtt(mMSz, mMrk);
 if ( mCmapid != CMAP_OTHER ) dr3->SetColMapId(mCmapid);
@@ -1407,4 +1413,11 @@
   mLAtt = lat;
 }
+
+/* --Methode-- */
+void PIStdImgApp::SetFontName(PIFontName fn)
+{
+  mFName = fn;
+}
+
 /* --Methode-- */
 void PIStdImgApp::SetFontAtt(PIFontSize fsz, PIFontAtt fat)
@@ -1455,4 +1468,5 @@
   mSBCol = mBCol;
   mSLAtt = mLAtt;
+  mSFName = mFName;
   mSFSz = mFSz;
   mSFAtt = mFAtt;
@@ -1482,4 +1496,5 @@
   mBCol = mSBCol;
   mLAtt = mSLAtt;
+  mFName = mSFName;
   mFSz = mSFSz;
   mFAtt = mSFAtt;
Index: /trunk/SophyaPI/PIext/pistdimgapp.h
===================================================================
--- /trunk/SophyaPI/PIext/pistdimgapp.h	(revision 1568)
+++ /trunk/SophyaPI/PIext/pistdimgapp.h	(revision 1569)
@@ -96,4 +96,5 @@
                      PIColors bg=PI_NotDefColor);
      void  SetLineAtt(PILineAtt lat=PI_NotDefLineAtt);
+     void  SetFontName(PIFontName fn=PI_DefaultFont);
      void  SetFontAtt(PIFontSize fsz=PI_NotDefFontSize,
                       PIFontAtt fat=PI_NotDefFontAtt);
@@ -171,4 +172,5 @@
     PIColors     mFCol, mBCol, mSFCol, mSBCol;
     PILineAtt    mLAtt, mSLAtt;
+    PIFontName   mFName, mSFName;
     PIFontSize   mFSz, mSFSz;
     PIFontAtt    mFAtt, mSFAtt;
Index: /trunk/SophyaPI/PIext/servnobjm.cc
===================================================================
--- /trunk/SophyaPI/PIext/servnobjm.cc	(revision 1568)
+++ /trunk/SophyaPI/PIext/servnobjm.cc	(revision 1569)
@@ -1365,4 +1365,5 @@
   mImgapp->SetColAtt();
   mImgapp->SetLineAtt();
+  mImgapp->SetFontName();
   mImgapp->SetFontAtt();
   mImgapp->SetMarkerAtt();
@@ -1446,4 +1447,8 @@
   if (it != GrAfonts.end())  { mImgapp->SetFontAtt((PIFontSize)((*it).second.a2), (PIFontAtt)((*it).second.a1) ); 
                                fgsrgr = true;  continue; }
+  // Si c'est un nom de fontes
+  it = GrAfontNames.find(grt[k]);
+  if (it != GrAfontNames.end()) { mImgapp->SetFontName((PIFontName)((*it).second.a1));
+                                 fgsrgr = true;  continue; }
   // Si c'est un attribut de markers
   it = GrAmarkers.find(grt[k]);
@@ -1534,9 +1539,21 @@
 GrAlines["thickdottedline"] = gi;
 
-// Les fontes 
+// Noms de fontes
+gi.a2 = 0;
+gi.a1 = PI_DefaultFont;
+GrAfontNames["deffont"] = gi;
+gi.a1 = PI_CourierFont;
+GrAfontNames["courierfont"] = gi;
+gi.a1 = PI_HelveticaFont;
+GrAfontNames["helveticafont"] = gi;
+gi.a1 = PI_TimesFont;
+GrAfontNames["timesfont"] = gi;
+gi.a1 = PI_SymbolFont;
+GrAfontNames["symbolfont"] = gi;
+
+// Attributs de fontes 
 gi.a2 = PI_NotDefFontSize;
 gi.a1 = PI_NotDefFontAtt;
-GrAfonts["deffont"] = gi;
-
+GrAfontNames["deffontatt"] = gi;
 gi.a2 = PI_NormalSizeFont;
 gi.a1 = PI_RomanFont;
@@ -1546,4 +1563,6 @@
 gi.a1 = PI_ItalicFont;
 GrAfonts["italicfont"] = gi;
+gi.a1 = PI_BoldItalicFont;
+GrAfonts["bolditalicfont"] = gi;
 gi.a2 = PI_SmallSizeFont;
 gi.a1 = PI_RomanFont;
@@ -1553,4 +1572,6 @@
 gi.a1 = PI_ItalicFont;
 GrAfonts["smallitalicfont"] = gi;
+gi.a1 = PI_BoldItalicFont;
+GrAfonts["smallbolditalicfont"] = gi;
 gi.a2 = PI_BigSizeFont;
 gi.a1 = PI_RomanFont;
@@ -1560,4 +1581,6 @@
 gi.a1 = PI_ItalicFont;
 GrAfonts["bigitalicfont"] = gi;
+gi.a1 = PI_BoldItalicFont;
+GrAfonts["bigbolditalicfont"] = gi;
 gi.a2 = PI_HugeSizeFont;
 gi.a1 = PI_RomanFont;
@@ -1567,4 +1590,6 @@
 gi.a1 = PI_ItalicFont;
 GrAfonts["hugeitalicfont"] = gi;
+gi.a1 = PI_BoldItalicFont;
+GrAfonts["hugebolditalicfont"] = gi;
 
 
Index: /trunk/SophyaPI/PIext/servnobjm.h
===================================================================
--- /trunk/SophyaPI/PIext/servnobjm.h	(revision 1568)
+++ /trunk/SophyaPI/PIext/servnobjm.h	(revision 1569)
@@ -140,4 +140,5 @@
   GrAttNames GrAmarkers;
   GrAttNames GrAfonts;
+  GrAttNames GrAfontNames;
   GrAttNames GrAcmap;  
   GrAttNames GrAzoom;  