Index: trunk/SophyaProg/PrgUtil/Makefile
===================================================================
--- trunk/SophyaProg/PrgUtil/Makefile	(revision 1575)
+++ trunk/SophyaProg/PrgUtil/Makefile	(revision 1599)
@@ -15,11 +15,6 @@
 LIBSORA := $(LIBS)
 LDLIBS := $(LIBS) $(LDLIBS)
-PROGS = $(EXE)runcxx $(EXE)scanppf $(EXE)scanfits $(EXE)cl2map $(EXE)map2cl \
-        $(EXE)prjsmap $(EXE)cremskfrsph $(EXE)msksphere $(EXE)extrapsph \
-        $(EXE)extrap2sph
-
-PROBJS = $(OBJ)runcxx.o $(OBJ)scanppf.o $(OBJ)scanfits.o $(OBJ)cl2map.o \
-         $(OBJ)map2cl.o $(OBJ)prjsmap.o $(OBJ)cremskfrsph.o $(OBJ)msksphere.o \
-         $(OBJ)extrapsph.o $(OBJ)extrap2sph.o
+PROGS = $(EXE)runcxx $(EXE)scanppf $(EXE)scanfits 
+PROBJS = $(OBJ)runcxx.o $(OBJ)scanppf.o $(OBJ)scanfits.o 
 
 all: $(PROGS)
@@ -45,227 +40,4 @@
 	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ 
 
-cl2map: $(EXE)cl2map
-	@ echo cl2map done
-$(EXE)cl2map: $(OBJ)cl2map.o
-	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ 
-
-map2cl: $(EXE)map2cl
-	@ echo map2cl done
-$(EXE)map2cl: $(OBJ)map2cl.o
-	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ 
-
-prjsmap: $(EXE)prjsmap
-	@ echo prjsmap done
-$(EXE)prjsmap: $(OBJ)prjsmap.o
-	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ 
-
-cremskfrsph: $(EXE)cremskfrsph
-	@ echo cremskfrsph done
-$(EXE)cremskfrsph: $(OBJ)cremskfrsph.o
-	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ 
-
-msksphere: $(EXE)msksphere
-	@ echo msksphere done
-$(EXE)msksphere: $(OBJ)msksphere.o
-	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ 
-
-extrapsph: $(EXE)extrapsph
-	@ echo extrapsph done
-$(EXE)extrapsph: $(OBJ)extrapsph.o
-	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ 
-
-extrap2sph: $(EXE)extrap2sph
-	@ echo extrap2sph done
-$(EXE)extrap2sph: $(OBJ)extrap2sph.o
-	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ 
-
-: $(EXE)
-
-$(EXE):
-	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ 
-  
-$(OBJ)cl2map.o: cl2map.cc $(INC)machdefs.h \
- $(INC)nbmath.h \
- $(INC)smathconst.h \
- $(INC)timing.h \
- $(INC)array.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h \
- $(INC)tmatrix.h \
- $(INC)tvector.h \
- $(INC)matharr.h \
- $(INC)fioarr.h \
- $(INC)sopemtx.h \
- $(INC)skymap.h \
- $(INC)spherethetaphi.h \
- $(INC)sphericalmap.h \
- $(INC)pixelmap.h \
- $(INC)spherepos.h \
- $(INC)unitvector.h \
- $(INC)vector3d.h \
- $(INC)longlat.h \
- $(INC)utilgeom.h \
- $(INC)spherehealpix.h \
- $(INC)HEALPixUtils.h \
- $(INC)localmap.h \
- $(INC)fiospherethetaphi.h \
- $(INC)fiospherehealpix.h \
- $(INC)fiolocalmap.h \
- $(INC)samba.h \
- $(INC)alm.h \
- $(INC)nbrandom.h \
- $(INC)srandgen.h \
- $(INC)triangmtx.h \
- $(INC)bruit.h \
- $(INC)circle.h \
- $(INC)geometry.h \
- $(INC)lambdaBuilder.h \
- $(INC)misstime.h \
- $(INC)mlobe.h \
- $(INC)prefcount.h \
- $(INC)scan.h \
- $(INC)sphericaltransformserver.h \
- $(INC)fftservintf.h \
- $(INC)fftpserver.h \
- $(INC)tod.h \
- $(INC)sambainit.h \
- $(INC)skymapinit.h \
- $(INC)sophyainit.h \
- $(INC)ntoolsinit.h \
- $(INC)tarrinit.h \
- $(INC)fitsspherehealpix.h \
- $(INC)fitsfile.h \
- $(INC)fitstarray.h
-$(OBJ)map2cl.o: map2cl.cc $(INC)machdefs.h \
- $(INC)nbmath.h \
- $(INC)smathconst.h \
- $(INC)timing.h \
- $(INC)array.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h \
- $(INC)tmatrix.h \
- $(INC)tvector.h \
- $(INC)matharr.h \
- $(INC)fioarr.h \
- $(INC)sopemtx.h \
- $(INC)skymap.h \
- $(INC)spherethetaphi.h \
- $(INC)sphericalmap.h \
- $(INC)pixelmap.h \
- $(INC)spherepos.h \
- $(INC)unitvector.h \
- $(INC)vector3d.h \
- $(INC)longlat.h \
- $(INC)utilgeom.h \
- $(INC)spherehealpix.h \
- $(INC)HEALPixUtils.h \
- $(INC)localmap.h \
- $(INC)fiospherethetaphi.h \
- $(INC)fiospherehealpix.h \
- $(INC)fiolocalmap.h \
- $(INC)samba.h \
- $(INC)alm.h \
- $(INC)nbrandom.h \
- $(INC)srandgen.h \
- $(INC)triangmtx.h \
- $(INC)bruit.h \
- $(INC)circle.h \
- $(INC)geometry.h \
- $(INC)lambdaBuilder.h \
- $(INC)misstime.h \
- $(INC)mlobe.h \
- $(INC)prefcount.h \
- $(INC)scan.h \
- $(INC)sphericaltransformserver.h \
- $(INC)fftservintf.h \
- $(INC)fftpserver.h \
- $(INC)tod.h \
- $(INC)sambainit.h \
- $(INC)skymapinit.h \
- $(INC)sophyainit.h \
- $(INC)ntoolsinit.h \
- $(INC)tarrinit.h \
- $(INC)fitsspherehealpix.h \
- $(INC)fitsfile.h \
- $(INC)fitstarray.h
-$(OBJ)prjsmap.o: prjsmap.cc $(INC)machdefs.h \
- $(INC)nbmath.h \
- $(INC)smathconst.h \
- $(INC)timing.h \
- $(INC)array.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h \
- $(INC)tmatrix.h \
- $(INC)tvector.h \
- $(INC)matharr.h \
- $(INC)fioarr.h \
- $(INC)sopemtx.h \
- $(INC)skymap.h \
- $(INC)spherethetaphi.h \
- $(INC)sphericalmap.h \
- $(INC)pixelmap.h \
- $(INC)spherepos.h \
- $(INC)unitvector.h \
- $(INC)vector3d.h \
- $(INC)longlat.h \
- $(INC)utilgeom.h \
- $(INC)spherehealpix.h \
- $(INC)HEALPixUtils.h \
- $(INC)localmap.h \
- $(INC)fiospherethetaphi.h \
- $(INC)fiospherehealpix.h \
- $(INC)fiolocalmap.h \
- $(INC)samba.h \
- $(INC)alm.h \
- $(INC)nbrandom.h \
- $(INC)srandgen.h \
- $(INC)triangmtx.h \
- $(INC)bruit.h \
- $(INC)circle.h \
- $(INC)geometry.h \
- $(INC)lambdaBuilder.h \
- $(INC)misstime.h \
- $(INC)mlobe.h \
- $(INC)prefcount.h \
- $(INC)scan.h \
- $(INC)sphericaltransformserver.h \
- $(INC)fftservintf.h \
- $(INC)fftpserver.h \
- $(INC)tod.h \
- $(INC)sambainit.h \
- $(INC)skymapinit.h \
- $(INC)sophyainit.h \
- $(INC)ntoolsinit.h \
- $(INC)tarrinit.h \
- $(INC)fitsspherehealpix.h \
- $(INC)fitsfile.h \
- $(INC)fitstarray.h
 $(OBJ)runcxx.o: runcxx.cc $(INC)sambainit.h \
  $(INC)skymapinit.h \
@@ -308,142 +80,2 @@
  $(INC)ntoolsinit.h \
  $(INC)tarrinit.h
-$(OBJ)cremskfrsph.o: cremskfrsph.cc \
- $(INC)machdefs.h \
- $(INC)skymapinit.h \
- $(INC)sophyainit.h \
- $(INC)skymap.h \
- $(INC)spherethetaphi.h \
- $(INC)sphericalmap.h \
- $(INC)smathconst.h \
- $(INC)pixelmap.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)spherepos.h \
- $(INC)unitvector.h \
- $(INC)vector3d.h \
- $(INC)longlat.h \
- $(INC)utilgeom.h \
- $(INC)tvector.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h \
- $(INC)spherehealpix.h \
- $(INC)HEALPixUtils.h \
- $(INC)localmap.h \
- $(INC)fiospherethetaphi.h \
- $(INC)fiospherehealpix.h \
- $(INC)fiolocalmap.h \
- $(INC)fitsspherehealpix.h \
- $(INC)fitsfile.h
-$(OBJ)extrapsph.o: extrapsph.cc \
- $(INC)machdefs.h \
- $(INC)skymapinit.h \
- $(INC)sophyainit.h \
- $(INC)skymap.h \
- $(INC)spherethetaphi.h \
- $(INC)sphericalmap.h \
- $(INC)smathconst.h \
- $(INC)pixelmap.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)spherepos.h \
- $(INC)unitvector.h \
- $(INC)vector3d.h \
- $(INC)longlat.h \
- $(INC)utilgeom.h \
- $(INC)tvector.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h \
- $(INC)spherehealpix.h \
- $(INC)HEALPixUtils.h \
- $(INC)localmap.h \
- $(INC)fiospherethetaphi.h \
- $(INC)fiospherehealpix.h \
- $(INC)fiolocalmap.h \
- $(INC)fitsspherehealpix.h \
- $(INC)fitsfile.h
-$(OBJ)extrap2sph.o: extrap2sph.cc \
- $(INC)machdefs.h \
- $(INC)skymapinit.h \
- $(INC)sophyainit.h \
- $(INC)skymap.h \
- $(INC)spherethetaphi.h \
- $(INC)sphericalmap.h \
- $(INC)smathconst.h \
- $(INC)pixelmap.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)spherepos.h \
- $(INC)unitvector.h \
- $(INC)vector3d.h \
- $(INC)longlat.h \
- $(INC)utilgeom.h \
- $(INC)tvector.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h \
- $(INC)spherehealpix.h \
- $(INC)HEALPixUtils.h \
- $(INC)localmap.h \
- $(INC)fiospherethetaphi.h \
- $(INC)fiospherehealpix.h \
- $(INC)fiolocalmap.h \
- $(INC)fitsspherehealpix.h \
- $(INC)fitsfile.h
-$(OBJ)msksphere.o: msksphere.cc \
- $(INC)machdefs.h \
- $(INC)skymapinit.h \
- $(INC)sophyainit.h \
- $(INC)skymap.h \
- $(INC)spherethetaphi.h \
- $(INC)sphericalmap.h \
- $(INC)smathconst.h \
- $(INC)pixelmap.h \
- $(INC)ppersist.h \
- $(INC)pexceptions.h \
- $(INC)gnumd5.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)spherepos.h \
- $(INC)unitvector.h \
- $(INC)vector3d.h \
- $(INC)longlat.h \
- $(INC)utilgeom.h \
- $(INC)tvector.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h \
- $(INC)spherehealpix.h \
- $(INC)HEALPixUtils.h \
- $(INC)localmap.h \
- $(INC)fiospherethetaphi.h \
- $(INC)fiospherehealpix.h \
- $(INC)fiolocalmap.h \
- $(INC)fitsspherehealpix.h \
- $(INC)fitsfile.h
Index: trunk/SophyaProg/PrgUtil/programs
===================================================================
--- trunk/SophyaProg/PrgUtil/programs	(revision 1575)
+++ trunk/SophyaProg/PrgUtil/programs	(revision 1599)
@@ -2,8 +2,2 @@
 scanppf scanppf.o
 scanfits scanfits.o
-cl2map cl2map.o
-map2cl map2cl.o
-prjsmap prjsmap.o
-cremskfrsph cremskfrsph.o
-extrapsph extrapsph.o
-extrap2sph extrap2sph.o