Index: /trunk/SophyaLib/Mgr/Makefile
===================================================================
--- /trunk/SophyaLib/Mgr/Makefile	(revision 1603)
+++ /trunk/SophyaLib/Mgr/Makefile	(revision 1604)
@@ -4,6 +4,6 @@
 include Mgr/Makefile.slb
 
-LIBF =  $(LIB)libSysTools.a $(LIB)libTArray.a $(LIB)libNTools.a $(LIB)libHiStats.a $(LIB)libSkyMap.a $(LIB)libSamba.a $(LIB)libSkyT.a
-LIBS = -L$(LIB) -lSysTools -lTArray -lNTools -lHiStats -lSkyMap -lSamba -lSkyT
+LIBF =  $(LIB)libBaseTools.a $(LIB)libSysTools.a $(LIB)libUtils.a $(LIB)libTArray.a $(LIB)libNTools.a $(LIB)libHiStats.a $(LIB)libSkyMap.a $(LIB)libSamba.a $(LIB)libSkyT.a
+LIBS = -L$(LIB) -lBaseTools -lSysTools -lUtils -lTArray -lNTools -lHiStats -lSkyMap -lSamba -lSkyT
 
 defaut: libs
@@ -15,5 +15,5 @@
 extlibs: cxxextlibs
 
-cxxlibs:  SysTools TArray NTools HiStats SkyMap Samba SkyT
+cxxlibs:  BaseTools SysTools Utils TArray NTools HiStats SkyMap Samba SkyT
 
 cxxextlibs:  FitsIOServer IFFTW LinAlg XAstroPack
@@ -39,7 +39,15 @@
 #--------------------------------------------------------------------
 
+.PHONY:  BaseTools
+BaseTools:
+	if [ -d BaseTools ] ; then cd  BaseTools ; $(MAKE) ; fi
+
 .PHONY:  SysTools
 SysTools:
 	if [ -d SysTools ] ; then cd  SysTools ; $(MAKE) ; fi
+
+.PHONY:  Utils
+Utils:
+	if [ -d Utils ] ; then cd  Utils ; $(MAKE) ; fi
  
 .PHONY:  TArray
@@ -90,5 +98,5 @@
  
 #  List of libraries (.a)
-PSLB =  $(LIB)libSysTools.a $(LIB)libTArray.a $(LIB)libNTools.a $(LIB)libHiStats.a $(LIB)libSkyMap.a $(LIB)libSamba.a $(LIB)libSkyT.a
+PSLB =  $(LIB)libBaseTools.a $(LIB)libSysTools.a $(LIB)libUtils.a $(LIB)libTArray.a $(LIB)libNTools.a $(LIB)libHiStats.a $(LIB)libSkyMap.a $(LIB)libSamba.a $(LIB)libSkyT.a
 EXTPSLB =  $(LIB)libFitsIOServer.a $(LIB)libIFFTW.a $(LIB)libLinAlg.a $(LIB)libXAstroPack.a
 PIPSLB =  $(LIB)libPI.a  $(LIB)libPIext.a
@@ -131,5 +139,7 @@
  
 # List of .o files for each module
+OBJBaseTools = $(shell echo `cat ./BaseTools/objlist.list `)
 OBJSysTools = $(shell echo `cat ./SysTools/objlist.list `)
+OBJUtils = $(shell echo `cat ./Utils/objlist.list `)
 OBJTArray = $(shell echo `cat ./TArray/objlist.list `)
 OBJNTools = $(shell echo `cat ./NTools/objlist.list `)
@@ -138,5 +148,5 @@
 OBJSamba = $(shell echo `cat ./Samba/objlist.list `)
 OBJSkyT = $(shell echo `cat ./SkyT/objlist.list `)
-ALLOBJS = $(OBJSysTools) $(OBJTArray) $(OBJNTools) $(OBJHiStats) $(OBJSkyMap) $(OBJSamba) $(OBJSkyT)
+ALLOBJS = $(OBJBaseTools) $(OBJSysTools) $(OBJUtils) $(OBJTArray) $(OBJNTools) $(OBJHiStats) $(OBJSkyMap) $(OBJSamba) $(OBJSkyT)
  
 # List of .o files modules with reference to external libraries
Index: /trunk/SophyaLib/Mgr/Makefile.am
===================================================================
--- /trunk/SophyaLib/Mgr/Makefile.am	(revision 1603)
+++ /trunk/SophyaLib/Mgr/Makefile.am	(revision 1604)
@@ -1,2 +1,2 @@
-SUBDIRS = include SysTools TArray HiStats NTools SkyMap Samba SkyT
+SUBDIRS = include BaseTools SysTools Utils TArray HiStats NTools SkyMap Samba SkyT
 
Index: /trunk/SophyaLib/Mgr/README
===================================================================
--- /trunk/SophyaLib/Mgr/README	(revision 1603)
+++ /trunk/SophyaLib/Mgr/README	(revision 1604)
@@ -7,5 +7,7 @@
 
 * Mgr/           Scripts for code management and makefiles
-* SysTools/      General architecture support classes
+* BaseTools/     General architecture support classes
+* SysTools/      Interface to various services provided by the operating system
+* Utils/         Utility classes and functions
 * TArray/        Template numerical arrays, vectors and matrices
 * SkyMap/        Local and full sky maps
@@ -29,4 +31,6 @@
 * PrgUtil/       Utility main programs
 
+* PrgMap/        Utility main programs for sky map manipulation
+
 
 * PI/            GUI class library
@@ -43,5 +47,5 @@
 Operating system            Compiler
 ......................................................................
-Compaq/DEC OSF 4.0           cxx 6.1         (shared-library only)
+Compaq/DEC OSF 4.0           cxx 6.x         (shared-library only)
 Compaq/DEC OSF 4.0           g++ 2.95        (shared-library only)
 SGI                          CC  7.30        (   "    "      "   )
Index: /trunk/SophyaLib/Mgr/configure.in
===================================================================
--- /trunk/SophyaLib/Mgr/configure.in	(revision 1603)
+++ /trunk/SophyaLib/Mgr/configure.in	(revision 1604)
@@ -45,5 +45,5 @@
 AC_CHECK_FUNCS(nice)
 
-cp $srcdir/SysTools/machdefs_ac.h machdefs.h
+cp $srcdir/BaseTools/machdefs_ac.h machdefs.h
 
 
@@ -61,5 +61,5 @@
 
 
-for xdir in SysTools TArray HiStats NTools SkyMap Samba SkyT; do
+for xdir in BaseTools SysTools Utils TArray HiStats NTools SkyMap Samba SkyT; do
   if test -d $incsrcdir/$xdir ; then
      for fn in $incsrcdir/$xdir/*.h; do
@@ -71,5 +71,6 @@
 cd ..
 
-AC_OUTPUT(Makefile include/Makefile SysTools/Makefile TArray/Makefile
+AC_OUTPUT(Makefile include/Makefile BaseTools/Makefile SysTools/Makefile 
+                   Utils/Makefile   TArray/Makefile
                    HiStats/Makefile NTools/Makefile   SkyMap/Makefile
                    Samba/Makefile   SkyT/Makefile)
Index: /trunk/SophyaLib/Mgr/makefileuser.inc
===================================================================
--- /trunk/SophyaLib/Mgr/makefileuser.inc	(revision 1603)
+++ /trunk/SophyaLib/Mgr/makefileuser.inc	(revision 1604)
@@ -29,7 +29,7 @@
 
 #--------- lib sophya ---------
-LIBF := $(LIBF) $(LIB)libSysTools.a $(LIB)libNTools.a $(LIB)libTArray.a $(LIB)libHiStats.a 
+LIBF := $(LIBF) $(LIB)libBaseTools.a $(LIB)libSysTools.a $(LIB)libUtils.a $(LIB)libNTools.a $(LIB)libTArray.a $(LIB)libHiStats.a 
 LIBF := $(LIBF) $(LIB)libSamba.a $(LIB)libSkyMap.a $(LIB)libSkyT.a
-LIBS := $(LIBS) -L$(LIB) -lSysTools -lNTools -lTArray -lHiStats -lSamba -lSkyMap -lSkyT
+LIBS := $(LIBS) -L$(LIB) -lBaseTools -lSysTools -lUtils -lNTools -lTArray -lHiStats -lSamba -lSkyMap -lSkyT
 
 #--------- lib sophya interface externes ---------
Index: /trunk/SophyaLib/Mgr/mkslbsgi.csh
===================================================================
--- /trunk/SophyaLib/Mgr/mkslbsgi.csh	(revision 1603)
+++ /trunk/SophyaLib/Mgr/mkslbsgi.csh	(revision 1604)
@@ -29,5 +29,7 @@
 
 
+set OBJBaseTools = `cat ./BaseTools/objlist.list `
 set OBJSysTools = `cat ./SysTools/objlist.list `
+set OBJUtils = `cat ./Utils/objlist.list `
 set OBJTArray = `cat ./TArray/objlist.list `
 set OBJNTools = `cat ./NTools/objlist.list `
@@ -36,5 +38,5 @@
 set OBJSamba = `cat ./Samba/objlist.list `
 set OBJSkyT = `cat ./SkyT/objlist.list `
-set ALLOBJS = ($OBJSysTools  $OBJTArray $OBJNTools  $OBJHiStats  $OBJSkyMap $OBJSamba $OBJSkyT)
+set ALLOBJS = ($OBJBaseTools $OBJSysTools $OBJUtils $OBJTArray $OBJNTools  $OBJHiStats  $OBJSkyMap $OBJSamba $OBJSkyT)
 	
 set OBJFitsIOServer = `cat ./FitsIOServer/objlist.list `