Index: trunk/SophyaLib/BaseTools/basetools.h
===================================================================
--- trunk/SophyaLib/BaseTools/basetools.h	(revision 1607)
+++ trunk/SophyaLib/BaseTools/basetools.h	(revision 1607)
@@ -0,0 +1,22 @@
+#ifndef BASETOOLS_H
+#define BASETOOLS_H
+
+/*!
+   \defgroup BaseTools BaseTools module
+   This module contains classes and functions which define the 
+   general framework for \b Sophya package such as the simple
+   persistence, serialisation mechanism through \b PPersist,
+   \b POutPersist, \b PInPersist classes. It contains also
+   few utility classes such as the \b NDataBlock<T>, (template 
+   numerical arrays with reference counting and sharing).
+*/
+
+#include "sophyainit.h"
+#include "ppersist.h"
+#include "ndatablock.h"
+#include "anydataobj.h"
+#include "dvlist.h"
+#include "perrors.h"
+#include "srandgen.h"
+
+#endif
Index: trunk/SophyaLib/BaseTools/dvlist.cc
===================================================================
--- trunk/SophyaLib/BaseTools/dvlist.cc	(revision 1605)
+++ trunk/SophyaLib/BaseTools/dvlist.cc	(revision 1607)
@@ -12,5 +12,5 @@
 //++
 // Class	DVList
-// Lib		SysTools
+// Lib		BaseTools
 // include	dvlist.h
 //
@@ -44,5 +44,5 @@
 /*!
    \class SOPHYA::DVList
-   \ingroup SysTools
+   \ingroup BaseTools
    This class can be used to construct list of values associated with names.
    Variables names should not contain space characters and is limited to 64
Index: trunk/SophyaLib/BaseTools/mutyv.cc
===================================================================
--- trunk/SophyaLib/BaseTools/mutyv.cc	(revision 1605)
+++ trunk/SophyaLib/BaseTools/mutyv.cc	(revision 1607)
@@ -12,5 +12,5 @@
 /*!
    \class SOPHYA::MuTyV
-   \ingroup SysTools
+   \ingroup BaseTools
    Simple utility class which can be used to hold values of type
    string, integer (\b int_8) or float (\b r_8) as well as complex,
Index: trunk/SophyaLib/BaseTools/ndatablock.cc
===================================================================
--- trunk/SophyaLib/BaseTools/ndatablock.cc	(revision 1605)
+++ trunk/SophyaLib/BaseTools/ndatablock.cc	(revision 1607)
@@ -12,5 +12,5 @@
 /*!
   \class SOPHYA::NDataBlock
-  \ingroup SysTools
+  \ingroup BaseTools
   Management of data blocks
 */
Index: trunk/SophyaLib/BaseTools/ndatablock.h
===================================================================
--- trunk/SophyaLib/BaseTools/ndatablock.h	(revision 1605)
+++ trunk/SophyaLib/BaseTools/ndatablock.h	(revision 1607)
@@ -18,5 +18,5 @@
 /*!
   \class Bridge
-  \ingroup SysTools
+  \ingroup BaseTools
   This class is use by NDataBlock. It allows sharing of datas
   with external structures : by example, if you want to connect
Index: trunk/SophyaLib/BaseTools/pexceptions.h
===================================================================
--- trunk/SophyaLib/BaseTools/pexceptions.h	(revision 1605)
+++ trunk/SophyaLib/BaseTools/pexceptions.h	(revision 1607)
@@ -17,5 +17,5 @@
   string BuildLongExceptionMessage(const char * s, const char *file, int line);
 
-/*! \ingroup SysTools
+/*! \ingroup BaseTools
     \brief Base exception class in Sophya
 
@@ -43,5 +43,5 @@
 //      PException
   
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief A PError is a serious logic error. Usually not caught... */
   class PError : public PThrowable {
@@ -50,5 +50,5 @@
   };
   
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief A PException is not as serious... Can be caught. */
   class PException : public PThrowable {
@@ -64,5 +64,5 @@
 //     AssertionFailedError
 
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief Memory allocation failure */
   class AllocationError : public PError {
@@ -71,5 +71,5 @@
   };
   
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief Null pointer error */
   class NullPtrError : public PError {
@@ -79,5 +79,5 @@
   
   
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief Calling a forbidden method, trying a forbidden operation */
   class ForbiddenError : public PError {
@@ -87,5 +87,5 @@
 
   
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief ASSERT macro failure. The message is the assertion... */
   class AssertionFailedError : public PError {
@@ -109,5 +109,5 @@
   //   CaughtSignalExc
   
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief Generic IO Exception */
   class IOExc : public PException {
@@ -116,5 +116,5 @@
   };
 
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief Bad file format */
   class FileFormatExc : public IOExc {
@@ -123,5 +123,5 @@
   };
 
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief Size mismatch between objects */
   class SzMismatchError : public PException {
@@ -130,5 +130,5 @@
   };
   
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief Out of bounds for array, matrix, etc */
   class RangeCheckError : public PException {
@@ -137,5 +137,5 @@
   };
   
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief Invalid parameter to method/constructor... */
   class ParmError : public PException {
@@ -144,5 +144,5 @@
   };
 
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief Calling a non available / not implemented method */
   class NotAvailableOperation : public PException {
@@ -151,5 +151,5 @@
   };
 
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief Bad data type -> keep ? */
   class TypeMismatchExc : public PException {
@@ -158,5 +158,5 @@
   };
 
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief Math operation exception */
   class MathExc : public PException {
@@ -165,5 +165,5 @@
   };
   
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief Singular matrix  */
   class SingMatrixExc : public MathExc {
@@ -172,5 +172,5 @@
   };
 
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief Duplicate identifier during registration */
   class DuplicateIdExc : public PException {
@@ -179,5 +179,5 @@
   };
   
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief Not found identifier  */
   class NotFoundExc : public PException {
@@ -186,5 +186,5 @@
   };
   
-/*! \ingroup SysTools 
+/*! \ingroup BaseTools 
     \brief Generated exception when processing a signal */
   class CaughtSignalExc : public PException {
Index: trunk/SophyaLib/BaseTools/sophyainit.cc
===================================================================
--- trunk/SophyaLib/BaseTools/sophyainit.cc	(revision 1605)
+++ trunk/SophyaLib/BaseTools/sophyainit.cc	(revision 1607)
@@ -25,18 +25,6 @@
 
 /*!
-   \defgroup SysTools SysTools module
-   This module contains classes and functions which define the 
-   general framework for \b Sophya package such as the simple
-   persistence, serialisation mechanism through \b PPersist,
-   \b POutPersist, \b PInPersist classes. It contains also
-   few utility classes such as the \b NDataBlock<T>, (template 
-   numerical arrays with reference counting and sharing)
-   \b DataCards and \b PDynLinker (Dynamic link handler) classes.  
-  
-*/
-
-/*!
   \class SOPHYA::SophyaInitiator
-  \ingroup SysTools
+  \ingroup BaseTools
   Each Sophya module may contain an initialiser class which should
   be a sub-class of SophyaInitiator.  
Index: trunk/SophyaLib/BaseTools/srandgen.c
===================================================================
--- trunk/SophyaLib/BaseTools/srandgen.c	(revision 1605)
+++ trunk/SophyaLib/BaseTools/srandgen.c	(revision 1607)
@@ -35,20 +35,17 @@
 */
 
-/*! \defgroup RandGen
-    Random number generators */
-
-/*! \ingroup  SysTools
+/*! \ingroup  BaseTools
     \fn frand01
     Returns a random number (float) with flat distribution between 0 ... 1
 */
-/*! \ingroup  SysTools
+/*! \ingroup  BaseTools
     \fn drand01
     Returns a random number (double) with flat distribution between 0 ... 1
 */
-/*! \ingroup  SysTools
+/*! \ingroup  BaseTools
     \fn frandpm1() 
     Returns a random number (float) with flat distribution between -1 ... 1
 */
-/*! \ingroup  SysTools
+/*! \ingroup  BaseTools
     \fn drandpm1() 
     Returns a random number (double) with flat distribution between -1 ... 1  
@@ -64,5 +61,5 @@
 */
 
-/*! \ingroup  SysTools
+/*! \ingroup  BaseTools
     Fast initialisation of the random number generator \c (drand48) 
     using a \c long type value (cf \c srand48 )
@@ -83,5 +80,5 @@
 --
 */
-/*! \ingroup  SysTools
+/*! \ingroup  BaseTools
     complete initialisation of the random number generator \c (drand48) 
     using a \c using 48 bits (cf \c seed48 )
@@ -103,5 +100,5 @@
 --
 */
-/*! \ingroup  SysTools
+/*! \ingroup  BaseTools
     Returns the status (48 bits) of the random number generator \c (drand48) 
     (cf \c seed48 )
@@ -135,5 +132,5 @@
 --
 */
-/*! \ingroup  SysTools
+/*! \ingroup  BaseTools
     Automatic initialisation using the present time
 */
@@ -187,5 +184,5 @@
 --
 */
-/*! \ingroup  SysTools
+/*! \ingroup  BaseTools
     Normal (Gaussian) random number generator (Mean=0., Sigma=1.)
 */
@@ -230,5 +227,5 @@
 --
 */
-/*! \ingroup  SysTools
+/*! \ingroup  BaseTools
     Normal (Gaussian) random number generator with the specified mean
     (\c am ) and sigma (\c s )