Index: trunk/SophyaLib/Manual/mkmf
===================================================================
--- trunk/SophyaLib/Manual/mkmf	(revision 1608)
+++ trunk/SophyaLib/Manual/mkmf	(revision 1609)
@@ -23,5 +23,5 @@
 ##################################
 set allmodules = ( \
-  BaseTools SysTools Utils TArray NTools HiStats SkyMap Samba FitsIOServer PMixer SkyT \
+  BaseTools SysTools SUtils TArray NTools HiStats SkyMap Samba FitsIOServer PMixer SkyT \
   )
 unset modules; unset latex; unset html; unset man; unset rtf
Index: trunk/SophyaLib/Mgr/Makefile
===================================================================
--- trunk/SophyaLib/Mgr/Makefile	(revision 1608)
+++ trunk/SophyaLib/Mgr/Makefile	(revision 1609)
@@ -4,6 +4,6 @@
 include Mgr/Makefile.slb
 
-LIBF =  $(LIB)libBaseTools.a $(LIB)libSysTools.a $(LIB)libUtils.a $(LIB)libTArray.a $(LIB)libNTools.a $(LIB)libHiStats.a $(LIB)libSkyMap.a $(LIB)libSamba.a $(LIB)libSkyT.a
-LIBS = -L$(LIB) -lBaseTools -lSysTools -lUtils -lTArray -lNTools -lHiStats -lSkyMap -lSamba -lSkyT
+LIBF =  $(LIB)libBaseTools.a $(LIB)libSysTools.a $(LIB)libSUtils.a $(LIB)libTArray.a $(LIB)libNTools.a $(LIB)libHiStats.a $(LIB)libSkyMap.a $(LIB)libSamba.a $(LIB)libSkyT.a
+LIBS = -L$(LIB) -lBaseTools -lSysTools -lSUtils -lTArray -lNTools -lHiStats -lSkyMap -lSamba -lSkyT
 
 defaut: libs
@@ -15,5 +15,5 @@
 extlibs: cxxextlibs
 
-cxxlibs:  BaseTools SysTools Utils TArray NTools HiStats SkyMap Samba SkyT
+cxxlibs:  BaseTools SysTools SUtils TArray NTools HiStats SkyMap Samba SkyT
 
 cxxextlibs:  FitsIOServer IFFTW LinAlg XAstroPack
@@ -47,7 +47,7 @@
 	if [ -d SysTools ] ; then cd  SysTools ; $(MAKE) ; fi
 
-.PHONY:  Utils
-Utils:
-	if [ -d Utils ] ; then cd  Utils ; $(MAKE) ; fi
+.PHONY:  SUtils
+SUtils:
+	if [ -d SUtils ] ; then cd  SUtils ; $(MAKE) ; fi
  
 .PHONY:  TArray
@@ -98,5 +98,5 @@
  
 #  List of libraries (.a)
-PSLB =  $(LIB)libBaseTools.a $(LIB)libSysTools.a $(LIB)libUtils.a $(LIB)libTArray.a $(LIB)libNTools.a $(LIB)libHiStats.a $(LIB)libSkyMap.a $(LIB)libSamba.a $(LIB)libSkyT.a
+PSLB =  $(LIB)libBaseTools.a $(LIB)libSysTools.a $(LIB)libSUtils.a $(LIB)libTArray.a $(LIB)libNTools.a $(LIB)libHiStats.a $(LIB)libSkyMap.a $(LIB)libSamba.a $(LIB)libSkyT.a
 EXTPSLB =  $(LIB)libFitsIOServer.a $(LIB)libIFFTW.a $(LIB)libLinAlg.a $(LIB)libXAstroPack.a
 PIPSLB =  $(LIB)libPI.a  $(LIB)libPIext.a
@@ -141,5 +141,5 @@
 OBJBaseTools = $(shell echo `cat ./BaseTools/objlist.list `)
 OBJSysTools = $(shell echo `cat ./SysTools/objlist.list `)
-OBJUtils = $(shell echo `cat ./Utils/objlist.list `)
+OBJSUtils = $(shell echo `cat ./SUtils/objlist.list `)
 OBJTArray = $(shell echo `cat ./TArray/objlist.list `)
 OBJNTools = $(shell echo `cat ./NTools/objlist.list `)
@@ -148,5 +148,5 @@
 OBJSamba = $(shell echo `cat ./Samba/objlist.list `)
 OBJSkyT = $(shell echo `cat ./SkyT/objlist.list `)
-ALLOBJS = $(OBJBaseTools) $(OBJSysTools) $(OBJUtils) $(OBJTArray) $(OBJNTools) $(OBJHiStats) $(OBJSkyMap) $(OBJSamba) $(OBJSkyT)
+ALLOBJS = $(OBJBaseTools) $(OBJSysTools) $(OBJSUtils) $(OBJTArray) $(OBJNTools) $(OBJHiStats) $(OBJSkyMap) $(OBJSamba) $(OBJSkyT)
  
 # List of .o files modules with reference to external libraries
Index: trunk/SophyaLib/Mgr/Makefile.am
===================================================================
--- trunk/SophyaLib/Mgr/Makefile.am	(revision 1608)
+++ trunk/SophyaLib/Mgr/Makefile.am	(revision 1609)
@@ -1,2 +1,2 @@
-SUBDIRS = include BaseTools SysTools Utils TArray HiStats NTools SkyMap Samba SkyT
+SUBDIRS = include BaseTools SysTools SUtils TArray HiStats NTools SkyMap Samba SkyT
 
Index: trunk/SophyaLib/Mgr/README
===================================================================
--- trunk/SophyaLib/Mgr/README	(revision 1608)
+++ trunk/SophyaLib/Mgr/README	(revision 1609)
@@ -9,5 +9,5 @@
 * BaseTools/     General architecture support classes
 * SysTools/      Interface to various services provided by the operating system
-* Utils/         Utility classes and functions
+* SUtils/        Utility classes and functions
 * TArray/        Template numerical arrays, vectors and matrices
 * SkyMap/        Local and full sky maps
Index: trunk/SophyaLib/Mgr/configure.in
===================================================================
--- trunk/SophyaLib/Mgr/configure.in	(revision 1608)
+++ trunk/SophyaLib/Mgr/configure.in	(revision 1609)
@@ -61,5 +61,5 @@
 
 
-for xdir in BaseTools SysTools Utils TArray HiStats NTools SkyMap Samba SkyT; do
+for xdir in BaseTools SysTools SUtils TArray HiStats NTools SkyMap Samba SkyT; do
   if test -d $incsrcdir/$xdir ; then
      for fn in $incsrcdir/$xdir/*.h; do
@@ -72,5 +72,5 @@
 
 AC_OUTPUT(Makefile include/Makefile BaseTools/Makefile SysTools/Makefile 
-                   Utils/Makefile   TArray/Makefile
+                   SUtils/Makefile   TArray/Makefile
                    HiStats/Makefile NTools/Makefile   SkyMap/Makefile
                    Samba/Makefile   SkyT/Makefile)
Index: trunk/SophyaLib/Mgr/libdirs
===================================================================
--- trunk/SophyaLib/Mgr/libdirs	(revision 1608)
+++ trunk/SophyaLib/Mgr/libdirs	(revision 1609)
@@ -1,5 +1,5 @@
 BaseTools
 SysTools
-Utils
+SUtils
 TArray
 NTools
Index: trunk/SophyaLib/Mgr/makefileuser.inc
===================================================================
--- trunk/SophyaLib/Mgr/makefileuser.inc	(revision 1608)
+++ trunk/SophyaLib/Mgr/makefileuser.inc	(revision 1609)
@@ -29,7 +29,7 @@
 
 #--------- lib sophya ---------
-LIBF := $(LIBF) $(LIB)libBaseTools.a $(LIB)libSysTools.a $(LIB)libUtils.a $(LIB)libNTools.a $(LIB)libTArray.a $(LIB)libHiStats.a 
+LIBF := $(LIBF) $(LIB)libBaseTools.a $(LIB)libSysTools.a $(LIB)libSUtils.a $(LIB)libNTools.a $(LIB)libTArray.a $(LIB)libHiStats.a 
 LIBF := $(LIBF) $(LIB)libSamba.a $(LIB)libSkyMap.a $(LIB)libSkyT.a
-LIBS := $(LIBS) -L$(LIB) -lBaseTools -lSysTools -lUtils -lNTools -lTArray -lHiStats -lSamba -lSkyMap -lSkyT
+LIBS := $(LIBS) -L$(LIB) -lBaseTools -lSysTools -lSUtils -lNTools -lTArray -lHiStats -lSamba -lSkyMap -lSkyT
 
 #--------- lib sophya interface externes ---------
Index: trunk/SophyaLib/Mgr/mkslbsgi.csh
===================================================================
--- trunk/SophyaLib/Mgr/mkslbsgi.csh	(revision 1608)
+++ trunk/SophyaLib/Mgr/mkslbsgi.csh	(revision 1609)
@@ -31,5 +31,5 @@
 set OBJBaseTools = `cat ./BaseTools/objlist.list `
 set OBJSysTools = `cat ./SysTools/objlist.list `
-set OBJUtils = `cat ./Utils/objlist.list `
+set OBJSUtils = `cat ./SUtils/objlist.list `
 set OBJTArray = `cat ./TArray/objlist.list `
 set OBJNTools = `cat ./NTools/objlist.list `
@@ -38,5 +38,5 @@
 set OBJSamba = `cat ./Samba/objlist.list `
 set OBJSkyT = `cat ./SkyT/objlist.list `
-set ALLOBJS = ($OBJBaseTools $OBJSysTools $OBJUtils $OBJTArray $OBJNTools  $OBJHiStats  $OBJSkyMap $OBJSamba $OBJSkyT)
+set ALLOBJS = ($OBJBaseTools $OBJSysTools $OBJSUtils $OBJTArray $OBJNTools  $OBJHiStats  $OBJSkyMap $OBJSamba $OBJSkyT)
 	
 set OBJFitsIOServer = `cat ./FitsIOServer/objlist.list `
Index: trunk/SophyaLib/SUtils/Makefile
===================================================================
--- trunk/SophyaLib/SUtils/Makefile	(revision 1608)
+++ trunk/SophyaLib/SUtils/Makefile	(revision 1609)
@@ -1,9 +1,9 @@
 include ../Mgr/Makefile.h
  
-all: $(LIB)libUtils.a
+all: $(LIB)libSUtils.a
 clean:
 	rm -f $(OBJ)datacards.o $(OBJ)strutilxx.o $(OBJ)utils.o $(OBJ)strutil.o
-	rm -f $(LIB)libUtils.a
-$(LIB)libUtils.a : $(OBJ)datacards.o $(OBJ)strutil.o $(OBJ)strutilxx.o $(OBJ)utils.o
+	rm -f $(LIB)libSUtils.a
+$(LIB)libSUtils.a : $(OBJ)datacards.o $(OBJ)strutil.o $(OBJ)strutilxx.o $(OBJ)utils.o
 	$(ARCXX) $(ARCXXFLAGS) $@ $?
 ifeq ($(CXX),cxx)
Index: trunk/SophyaLib/SUtils/datacards.cc
===================================================================
--- trunk/SophyaLib/SUtils/datacards.cc	(revision 1608)
+++ trunk/SophyaLib/SUtils/datacards.cc	(revision 1609)
@@ -1,4 +1,4 @@
 //
-// $Id: datacards.cc,v 1.7 2001-07-31 08:06:06 cmv Exp $
+// $Id: datacards.cc,v 1.8 2001-07-31 14:02:38 cmv Exp $
 //
 //
@@ -18,5 +18,5 @@
 //++
 // Class	DataCards
-// Lib		Utils
+// Lib		SUtils
 // include	datacards.h
 //
@@ -38,5 +38,5 @@
 /*! 
     \class SOPHYA::DataCards
-    \ingroup Utils
+    \ingroup SUtils
     This class can be used for decoding program parameters from an ascii
     file. Each line of the ascii contains a keyword starting with \b @ .
Index: trunk/SophyaLib/SUtils/sutils.h
===================================================================
--- trunk/SophyaLib/SUtils/sutils.h	(revision 1608)
+++ trunk/SophyaLib/SUtils/sutils.h	(revision 1609)
@@ -3,5 +3,5 @@
 
 /*!
-   \defgroup Utils Utils module
+   \defgroup SUtils SUtils module
    This module contains general utility routines and classes
    for datacards, string manipulation etc...