Index: trunk/SophyaLib/NTools/objfitter.cc
===================================================================
--- trunk/SophyaLib/NTools/objfitter.cc	(revision 1623)
+++ trunk/SophyaLib/NTools/objfitter.cc	(revision 1624)
@@ -242,5 +242,4 @@
 {for(int i=0;i<npar;i++) par[i] = gfit.GetParm(i);}
 TMatrix<T> m(mtx,false);
-m.SetTemp(true);
 for(uint_4 i=0;i<mtx.NRows();i++) for(uint_4 j=0;j<mtx.NCols();j++) {
   double x[2] = {xorg+j*dx,yorg+i*dy};
@@ -275,5 +274,4 @@
 {for(int i=0;i<npar;i++) par[i] = gfit.GetParm(i);}
 TMatrix<T> m(mtx.NRows(), mtx.NCols());
-m.SetTemp(true);
 for(uint_4 i=0;i<mtx.NRows();i++) for(uint_4 j=0;j<mtx.NCols();j++) {
   double x[2] = {xorg+j*dx,yorg+i*dy};
@@ -304,5 +302,4 @@
 {for(int i=0;i<npar;i++) par[i] = gfit.GetParm(i);}
 TVector<T> v(vec,false);
-v.SetTemp(true);
 for(uint_4 i=0;i<vec.NElts();i++) {
   double x = xorg+i*dx;
@@ -332,5 +329,4 @@
 {for(int i=0;i<npar;i++) par[i] = gfit.GetParm(i);}
 TVector<T> v(vec.NElts());
-v.SetTemp(true);
 for(uint_4 i=0;i<vec.NElts();i++) {
   double x = xorg+i*dx;
@@ -363,5 +359,4 @@
 {for(int i=0;i<npar;i++) par[i] = gfit.GetParm(i);}
 Image<T> im(ima,false);
-im.SetTemp(true);
 for(uint_4 i=0;i<ima.XSize();i++) for(uint_4 j=0;j<ima.YSize();j++) {
   double x[2] = {ima.XPos(i),ima.YPos(j)};
@@ -388,5 +383,4 @@
 {for(int i=0;i<npar;i++) par[i] = gfit.GetParm(i);}
 Image<T> im(ima.XSize(),ima.YSize());
-im.SetTemp(true);
 for(uint_4 i=0;i<ima.XSize();i++) for(uint_4 j=0;j<ima.YSize();j++) {
   double x[2] = {ima.XPos(i),ima.YPos(j)};
Index: trunk/SophyaLib/Samba/sphericaltransformserver.cc
===================================================================
--- trunk/SophyaLib/Samba/sphericaltransformserver.cc	(revision 1623)
+++ trunk/SophyaLib/Samba/sphericaltransformserver.cc	(revision 1624)
@@ -341,5 +341,4 @@
   //sortie.ReSize(nph);
   TVector< complex<T> > sortie(nph);
-  sortie.SetTemp(true);
 
   fftIntfPtr_-> FFTBackward(data, sortie);
@@ -424,5 +423,4 @@
   //sortie.ReSize(nph);
   TVector<T> sortie;
-  sortie.SetTemp(true);
 
   fftIntfPtr_-> FFTBackward(data, sortie);
@@ -453,5 +451,4 @@
   TVector< complex<T> > phase(nmmax+1);
   Alm<T> alm;
-  alm.SetTemp(true);
   alm.ReSizeToLmax(nlmax);
   for (int_4 ith = 0; ith < map.NbThetaSlices(); ith++)
@@ -523,5 +520,4 @@
   //dataout.ReSize(nmmax+1);
   TVector< complex<T> > dataout(nmmax+1);
-  //  dataout.SetTemp(true);
 
   int im_max=min(nph,nmmax+1);
@@ -574,5 +570,4 @@
   //dataout.ReSize(nmmax+1);
   TVector< complex<T> > dataout(nmmax+1);
-  //  dataout.SetTemp(true); 
 
   // on transfere le resultat de la fft dans dataout.
Index: trunk/SophyaLib/SkyMap/fiolocalmap.cc
===================================================================
--- trunk/SophyaLib/SkyMap/fiolocalmap.cc	(revision 1623)
+++ trunk/SophyaLib/SkyMap/fiolocalmap.cc	(revision 1624)
@@ -26,5 +26,4 @@
 {
   dobj= new LocalMap<T>;
-  dobj->DataBlock().SetTemp(true);
   ownobj= true;
   Read(filename);
@@ -38,5 +37,4 @@
 {
   dobj= new LocalMap<T>(obj, true);
-  dobj->DataBlock().SetTemp(true);
   ownobj= true;
 }
@@ -89,5 +87,4 @@
     {
       dobj= new LocalMap<T>;
-      dobj->DataBlock().SetTemp(true);
       ownobj= true;
     }
Index: trunk/SophyaLib/SkyMap/fiospherehealpix.cc
===================================================================
--- trunk/SophyaLib/SkyMap/fiospherehealpix.cc	(revision 1623)
+++ trunk/SophyaLib/SkyMap/fiospherehealpix.cc	(revision 1624)
@@ -21,5 +21,4 @@
 {
   dobj_= new SphereHEALPix<T>;
-  dobj_->SetTemp(true);
   ownobj= true;
   Read(filename);
@@ -30,5 +29,4 @@
 {
   dobj_= new SphereHEALPix<T>(obj, true);
-  dobj_->SetTemp(true);
   ownobj= true;
 }
@@ -69,5 +67,4 @@
     {
       dobj_= new SphereHEALPix<T>;
-      dobj_->SetTemp(true);
       ownobj= true;      
     }
Index: trunk/SophyaLib/SkyMap/fiospherethetaphi.cc
===================================================================
--- trunk/SophyaLib/SkyMap/fiospherethetaphi.cc	(revision 1623)
+++ trunk/SophyaLib/SkyMap/fiospherethetaphi.cc	(revision 1624)
@@ -22,5 +22,4 @@
 {
   dobj= new SphereThetaPhi<T>;
-  dobj->pixels_.SetTemp(true);
   ownobj= true;
   Read(filename);
@@ -31,5 +30,4 @@
 {
   dobj= new SphereThetaPhi<T>(obj, true);
-  dobj->pixels_.SetTemp(true);
   ownobj= true;
 }
@@ -71,5 +69,4 @@
     {
       dobj= new SphereThetaPhi<T>;
-      dobj->pixels_.SetTemp(true);
       ownobj= true;      
     }
Index: trunk/SophyaLib/SkyMap/localmap.cc
===================================================================
--- trunk/SophyaLib/SkyMap/localmap.cc	(revision 1623)
+++ trunk/SophyaLib/SkyMap/localmap.cc	(revision 1624)
@@ -592,9 +592,9 @@
 /*! Substract a constant value \b a to a LocalMap */
 template <class T>
-LocalMap<T>& LocalMap<T>::Sub(T a) 
+LocalMap<T>& LocalMap<T>::Sub(T a,bool fginv) 
 {
   if (NbPixels()< 1) 
     throw RangeCheckError("LocalMap<T>::Sub(T )  - LocalMap not dimensionned ! ");
-  pixels_ -= a; 
+  pixels_.Sub(a,fginv); 
   return (*this);
 } 
Index: trunk/SophyaLib/SkyMap/localmap.h
===================================================================
--- trunk/SophyaLib/SkyMap/localmap.h	(revision 1623)
+++ trunk/SophyaLib/SkyMap/localmap.h	(revision 1624)
@@ -120,5 +120,5 @@
 inline  LocalMap<T>&  operator += (T x)  { return Add(x); }
 //! Substract \b x to all elements
-virtual LocalMap<T>& Sub(T a); 
+virtual LocalMap<T>& Sub(T a,bool fginv=false); 
 inline   LocalMap<T>&  operator -= (T x)  { return Sub(x); }
 //! Multiply all elements by \b x
Index: trunk/SophyaLib/SkyMap/spherehealpix.cc
===================================================================
--- trunk/SophyaLib/SkyMap/spherehealpix.cc	(revision 1623)
+++ trunk/SophyaLib/SkyMap/spherehealpix.cc	(revision 1624)
@@ -95,5 +95,4 @@
     }
   InitNul();
-  //  SetTemp(false);
   Pixelize(m);
   SetThetaSlices();
@@ -585,9 +584,9 @@
 /*! Substract a constant value \b a to a SphereHEALPix */
 template <class T>
-SphereHEALPix<T>& SphereHEALPix<T>::Sub(T a) 
+SphereHEALPix<T>& SphereHEALPix<T>::Sub(T a,bool fginv) 
 {
   if (NbPixels() < 1) 
     throw RangeCheckError("SphereHEALPix<T>::Sub(T )  - SphereHEALPix not dimensionned ! ");
-  pixels_ -= a; 
+  pixels_.Sub(a,fginv); 
   return (*this);
 } 
Index: trunk/SophyaLib/SkyMap/spherehealpix.h
===================================================================
--- trunk/SophyaLib/SkyMap/spherehealpix.h	(revision 1623)
+++ trunk/SophyaLib/SkyMap/spherehealpix.h	(revision 1624)
@@ -149,5 +149,5 @@
 inline  SphereHEALPix<T>&  operator += (T x)  { return Add(x); }
 //! Substract \b x to all elements
-virtual SphereHEALPix<T>& Sub(T a); 
+virtual SphereHEALPix<T>& Sub(T a,bool fginv=false); 
 inline   SphereHEALPix<T>&  operator -= (T x)  { return Sub(x); }
 //! Multiply all elements by \b x
Index: trunk/SophyaLib/SkyMap/spherethetaphi.cc
===================================================================
--- trunk/SophyaLib/SkyMap/spherethetaphi.cc	(revision 1623)
+++ trunk/SophyaLib/SkyMap/spherethetaphi.cc	(revision 1624)
@@ -751,9 +751,9 @@
 /*! Substract a constant value \b a to a SphereThetaPhi */
 template <class T>
-SphereThetaPhi<T>& SphereThetaPhi<T>::Sub(T a) 
+SphereThetaPhi<T>& SphereThetaPhi<T>::Sub(T a,bool fginv) 
 {
   if (NbPixels()< 1) 
     throw RangeCheckError("SphereThetaPhi<T>::Sub(T )  - SphereThetaPhi not dimensionned ! ");
-  pixels_ -= a; 
+  pixels_.Sub(a,fginv); 
   return (*this);
 } 
Index: trunk/SophyaLib/SkyMap/spherethetaphi.h
===================================================================
--- trunk/SophyaLib/SkyMap/spherethetaphi.h	(revision 1623)
+++ trunk/SophyaLib/SkyMap/spherethetaphi.h	(revision 1624)
@@ -201,5 +201,5 @@
 inline  SphereThetaPhi<T>&  operator += (T x)  { return Add(x); }
 //! Substract \b x to all elements
-virtual SphereThetaPhi<T>& Sub(T a); 
+virtual SphereThetaPhi<T>& Sub(T a,bool fginv=false); 
 inline   SphereThetaPhi<T>&  operator -= (T x)  { return Sub(x); }
 //! Multiply all elements by \b x
Index: trunk/SophyaLib/TArray/sopemtx.cc
===================================================================
--- trunk/SophyaLib/TArray/sopemtx.cc	(revision 1623)
+++ trunk/SophyaLib/TArray/sopemtx.cc	(revision 1624)
@@ -581,5 +581,4 @@
 if(GausPiv(a,b)==(T) 0)
   throw(MathExc("TMatrix Inverse() Singular Matrix"));
-b.SetTemp(true);
 return b;
 }
Index: trunk/SophyaLib/TArray/tmatrix.cc
===================================================================
--- trunk/SophyaLib/TArray/tmatrix.cc	(revision 1623)
+++ trunk/SophyaLib/TArray/tmatrix.cc	(revision 1624)
@@ -1,3 +1,3 @@
-// $Id: tmatrix.cc,v 1.21 2001-07-19 08:20:22 ansari Exp $
+// $Id: tmatrix.cc,v 1.22 2001-08-06 22:48:43 cmv Exp $
 //                         C.Magneville          04/99
 #include "machdefs.h"
@@ -238,5 +238,4 @@
   TMatrix sm(SubArray(rx, ry, Range(0), Range(0), Range(0)),true, mm);
   sm.UpdateMemoryMapping(mm);
-  sm.SetTemp(true);
   return(sm);
 }
@@ -284,5 +283,4 @@
     for(sa_size_t j=0; j<NCols(); j++) 
       tm(j,i) = (*this)(i,j);
-  tm.SetTemp(true);
   return tm;
 }
@@ -308,5 +306,4 @@
     for(sa_size_t j=0; j<NCols(); j++) 
       tm(i,j) = (*this)(i,j);
-  tm.SetTemp(true);
   return tm;
 }
@@ -409,5 +406,4 @@
     }
 
-  rm.SetTemp(true);
   return rm;
 }
Index: trunk/SophyaLib/TArray/triangmtx.h
===================================================================
--- trunk/SophyaLib/TArray/triangmtx.h	(revision 1623)
+++ trunk/SophyaLib/TArray/triangmtx.h	(revision 1624)
@@ -34,5 +34,4 @@
     elem_.ReSize(long_diag_*(long_diag_+1)/2);
   }
- inline void SetTemp(bool temp=false) const {elem_.SetTemp(temp);}
 
 //! Equal operator
Index: trunk/SophyaLib/TArray/tvector.cc
===================================================================
--- trunk/SophyaLib/TArray/tvector.cc	(revision 1623)
+++ trunk/SophyaLib/TArray/tvector.cc	(revision 1624)
@@ -1,3 +1,3 @@
-// $Id: tvector.cc,v 1.13 2001-07-03 15:41:56 ansari Exp $
+// $Id: tvector.cc,v 1.14 2001-08-06 22:48:43 cmv Exp $
 //                         C.Magneville          04/99
 #include "machdefs.h"
@@ -167,5 +167,4 @@
   TMatrix<T> const & mtx = (*this);
   TVector sv( mtx(rr, cr) , true, GetVectorType(), GetMemoryMapping() );
-  sv.SetTemp(true);
   return(sv);  
 }
Index: trunk/SophyaProg/PrgMap/prjsmap.cc
===================================================================
--- trunk/SophyaProg/PrgMap/prjsmap.cc	(revision 1623)
+++ trunk/SophyaProg/PrgMap/prjsmap.cc	(revision 1624)
@@ -133,5 +133,4 @@
   }
 
-  prj.SetTemp(true);
   return prj;   
 }
@@ -170,5 +169,4 @@
     }
   }
-  prj.SetTemp(true);
   return prj;   
 }